function y=extraImplMpr(y0,T,N,n)

% macro step
H = T/N;

% length of extrapolation sequence
k = length(n);

% sequence of micro steps
h=H./n;

% consistency order of implicit mid-point rule
p=2;

% initial values
y=y0;

Y=zeros(k,1);

% for each macro step
for ii=1:N
    
    %find an approximation for each microstep size
    for jj=1:k
        
        Y(jj)=ImplMpr( y, h(jj) , n(jj));
    end
    
    %extrapolate a better approximation
    y=extrapolate(Y,n,p);
    
end


